#include "StatList.hpp"


namespace drp::util {


template<class T>
StatList<T>::StatList() {
    this->updateModificationTime();
}

template<class T>
void StatList<T>::push_back(const T &value) {
    std::list<T>::push_back(value);
    this->updateModificationTime();
}

template<class T>
void StatList<T>::pop_back() {
    std::list<T>::pop_back();
    this->updateModificationTime();
}

template<class T>
std::chrono::time_point<std::chrono::high_resolution_clock> StatList<T>::getModificationTime() const {
    return this->modificationTime;
}


template<class T>
void StatList<T>::updateModificationTime() {
    this->modificationTime = std::chrono::high_resolution_clock::now();
}


}